Attribute VB_Name = "ConvModule"

Function GetLetteredDigit(InpNumber As Long, Optional Inverse As String) As String

'          

If IsMissing(Inverse) Then Inverse = vbNullString '  

Dim DGTS(100) As String

'   #       -
If InpNumber < 0 Or InpNumber > 51 Then
    GetLetteredDigit = "#"
    Exit Function
End If

'  -

DGTS(0) = "0"
DGTS(1) = "1"
DGTS(2) = "2"
DGTS(3) = "3"
DGTS(4) = "4"
DGTS(5) = "5"
DGTS(6) = "6"
DGTS(7) = "7"
DGTS(8) = "8"
DGTS(9) = "9"
DGTS(10) = "A"
DGTS(11) = "B"
DGTS(12) = "C"
DGTS(13) = "D"
DGTS(14) = "E"
DGTS(15) = "F"
DGTS(16) = "G"
DGTS(17) = "H"
DGTS(18) = "I"
DGTS(19) = "J"
DGTS(20) = "K"
DGTS(21) = "L"
DGTS(22) = "M"
DGTS(23) = "N"
DGTS(24) = "O"
DGTS(25) = "P"
DGTS(26) = "Q"
DGTS(27) = "R"
DGTS(28) = "S"
DGTS(29) = "T"
DGTS(30) = "U"
DGTS(31) = "V"
DGTS(32) = "W"
DGTS(33) = "X"
DGTS(34) = "Y"
DGTS(35) = "Z"

'  (  )

DGTS(36) = ""
DGTS(37) = ""
DGTS(38) = ""
DGTS(39) = ""
DGTS(40) = ""
DGTS(41) = ""
DGTS(42) = ""
DGTS(43) = ""
DGTS(44) = ""
DGTS(45) = ""
DGTS(46) = ""
DGTS(47) = ""
DGTS(48) = ""
DGTS(49) = ""
DGTS(50) = ""
DGTS(51) = ""

'   

Dim Sel As Integer
For Sel = 0 To 51

    If Inverse = DGTS(Sel) Then Inverse = CStr(Sel)
    
Next

'   

GetLetteredDigit = DGTS(InpNumber)

End Function

Function ConvDecToAny(DecValue As Long, BaseValue As Long) As String

'      

Dim D As Long, E As String, F As Long  ' 

' ,      
If DecValue = 0 Then
    ConvDecToAny = "0"
    Exit Function
End If

'     
'      
If BaseValue < 2 Then
    ConvDecToAny = "0"
    Exit Function
End If

D = DecValue '   

Do While DecValue > BaseValue
' , 
    D = Int(D / BaseValue)        ' 
    F = D * BaseValue             ' 
    F = DecValue - F              ' 
    E = GetLetteredDigit(F) + E   '  
    If DecValue <> D Then DecValue = D
'         

Loop '   

'   
If D = BaseValue Then
    D = 10              '    
    E = CStr(D) + E
Else
    E = GetLetteredDigit(D) + E
End If

ConvDecToAny = E '     

End Function '   

Function ConvAnyToDec(AnyValue As String, BaseValue As Long) As Long

'        

ConvAnyToDec = 0 '      

Dim A As String, B As String, C As Long ' 
Dim i As Integer, j As Integer

j = 0 '  

For i = Len(AnyValue) To 1 Step -1 '    
    A = Mid(AnyValue, i, 1)        '  
    Call GetLetteredDigit(1, A)    '  ,    
    If A >= BaseValue Then         ' ,    
        ConvAnyToDec = -1          '     
        Exit Function              '   : -1  
    End If
    C = C + Val(A) * BaseValue ^ j '    
    j = j + 1                      '  
Next

ConvAnyToDec = C                   '  

End Function

Function ConvAnyToAny(Value As String, InBase As Long, OutBase As Long) As String

Dim DecVal As Long
Dim Result As String

DecVal = ConvAnyToDec(Value, InBase)
Result = ConvDecToAny(DecVal, OutBase)

ConvAnyToAny = Result

End Function
